angular.module('WebTrax')

.constant('$ionicLoadingConfig', {
 	template: '<ion-spinner icon="android" class="spinner-energized"></ion-spinner>',
 	noBackdrop: false,
	hideOnStateChange: true
})

.config(function($stateProvider, $urlRouterProvider, $httpProvider, $ionicConfigProvider) {

	$ionicConfigProvider.backButton.previousTitleText(false).text('Back&emsp;').icon('ion-ios-arrow-back');
	$ionicConfigProvider.views.swipeBackEnabled(false);
	
	// add EDSAuthHttpResponseInterceptor
	$httpProvider.interceptors.push('EDSAuthHttpResponseInterceptor');
	
	$stateProvider.state('webtrax', {
		abstract: true,
		templateUrl: 'templates/webtrax.html'
	})

	.state('webtrax.login', {
		url: "/login",
		views: {
			contentView: {
				templateUrl: "templates/login.html",
				controller: 'LoginCtrl as vm'
			}
		}
	})
	
	.state('webtrax.wg-list', {
		url: '/wg-list',
		views: {
			contentView: {
				templateUrl: 'templates/wg-list.html',
				controller: 'WgListCtrl as vm'
			}
		}
	})
	
	.state('webtrax.wr-list', {
		url: '/wr-list/:wgId',
		views: {
			contentView: {
				templateUrl: 'templates/wr-list.html',
				controller: 'WrListCtrl as vm'
			},
			menuView: {
				templateUrl: 'templates/menu.html',
				controller: 'MenuCtrl as vm'
			}
		},
		params: {
			wgId: '',
			wgName: ''
		}
	})
	
	.state('webtrax.wr-details', {
		url: "/wr/:wrId",
		views: {
			contentView: {
				templateUrl: "templates/wr-details.html",
				controller: 'WrDetailsCtrl as vm'
			}
		},
		resolve: {
			wrDetails: function (WebTraxServices, $stateParams) {
				return WebTraxServices.getWrDetails($stateParams.wrId);
			}
		}
	});

	
	$urlRouterProvider.otherwise('/login');

});