angular.module('WebTrax.services')

.factory('EDSAuthHttpResponseInterceptor', ['$q', '$injector', 'ServiceConfig', function($q, $injector, ServiceConfig) {



    /**
     * retryServiceRequest
     * @param  {[type]} config   [description]
     * @param  {[type]} deferred [description]
     * @return {[type]}          [description]
     */
    function retryServiceRequest(config, deferred) {
        function successCallback(response) {
            deferred.resolve(response);
        }

        function errorCallback(response) {
            deferred.reject(response);
        }
        var $http = $injector.get('$http');
        $http(config).then(successCallback, errorCallback);
    }



    /**
     * [retryLogin description]
     * @return {[type]} [description]
     */
    function retryLogin() {
        var def = $q.defer();

        var $localstorage = $injector.get('$localstorage');
        var AuthServices = $injector.get('AuthServices');

        AuthServices.isAutoLoginSupported().then(function() {
            // check if we can re-login
            var _autoLogin = $localstorage.getAutoLogin();
            var _canReLogin = (_autoLogin == "ON");
            var currentUser = $localstorage.getCurrentUser();
            var _currentUser = currentUser || "";
            _canReLogin = _canReLogin && (_currentUser != "");

            // auto login   
            if (_canReLogin) {
                AuthServices.validAutoLoginInfo(currentUser).then(function() {
                	var _params = {
                        username: currentUser,
                        autologin: true
                    };

                    AuthServices.signIn(_params).then(function() {
                        def.resolve("AUTOLOGINSUCCESS");
                    });
                }).catch(function(err) {
                    def.reject("AUTOLOGINFAIL");
                });

            } else {
                def.reject("AUTOLOGINDISABLED");
            }

        }).catch(function(err) {
            def.reject("AUTOLOGINNOTSUPPORTED");
        });



        return def.promise;

    }



    var edsInterceptor = {
        responseError: function(response) {
            // check only service calls
            if (response.config.url.indexOf(ServiceConfig.ServicesURL) == 0) {
                if (response.status == 400 || response.status == 401) {
                    // try to reauthenticate
                    var deferred = $q.defer();

                    retryLogin().then(function(data) {
                    	// re-login worked fine, retry service request
                        retryServiceRequest(response.config, deferred);
                    }).catch(function(err) {
                    	// we fail on login, return original response
                        deferred.reject(response);
                    });
                    return deferred.promise;
                } else {
                    return response;
                }
            } else {
                return response;
            }

        }

    };

    return edsInterceptor;
}]);